"use strict";
this.name           = "SC check savegame compatiblity";
this.author         = "Lone_Wolf";
this.copyright      = "(C) 2011-2012, 2014-2015 Lone_Wolf.";
this.licence        = "CC-by-SA 4.0";
this.description    = "SC check savegame compatiblity";
this.version        = "1.12";

this._sc_check_savegame = function(savegame_version)
  {
    // return values
    // 0 : to old
    // 1 : conversion needed
    // 2 : missionvars not present, creation needed
    // 3 : missionvars present & correct version
    // 4 : to new
    if ( missionVariables.sc_settings == null )
      {
	// pre v1.10 or missionvars not created yet
	if ( missionVariables.sc_config !== null || missionVariables.sc_active !== null ) 
	  {
	    // if either of those are used, the savegame was created with a pre 0.21.2 version and to old
	    return 0;
	  }
	if ( missionVariables.sc_threshold !== null)
	  {
	    // missionVariables.sc_threshold exists, so savegame is from 0.21.2 or later, but before v1.10
	    // in higher versions conversion of this format will no longer be supported
	    return 1;
	  }
	// must be a new v1.10+ game, missionvars need to be created
	return 2;
      };
    // missionVariables.sc_settings  exists, so must be v1.10 or later and uses JSON
    var temp_settings = JSON.parse(missionVariables.sc_settings);
    var savegame_diff = savegame_version - temp_settings.general.savegame_version ;
    if ( savegame_diff  < -1 )
      { 
	// savegame format is more then 1 version behind of current version, conversion is not supported so to old
	return 0;
      }
    if ( savegame_diff == -1 )
      { 
	// savegame is 1 version behind, conversion supported
	// intended for future use when savegame_version > 0
	return 1;
      };
    if ( savegame_diff == 0 )
      { 
	// savegame format hasn't changed
	return 3;
      };
    // savegame was created with a newer version then supported by installed version of SC
    // should occur only when user has downgraded SC
    return 4;
  };
  