"use strict";
this.name           = "SC worldscript events";
this.author         = "Lone_Wolf";
this.copyright      = "(C) 2011-2012 , 2014-2015 Lone_Wolf.";
this.licence        = "CC-by-SA 4.0";
this.description    = "SC worldscript event handler";
this.version        = "1.12";

this.startUp = function()
  {
    if ( worldScripts["Shield Cycler"].startUp ) { worldScripts["Shield Cycler"].startUp(); };
  };

// worldscript events
this.guiScreenWillChange = function(to, from)
  {
    if ( to !== "GUI_SCREEN_MANIFEST" ) { mission.setInstructions(null); return; };
    if ( worldScripts["Shield Cycler"]._sc_settings.sc.version == worldScripts["Shield Cycler"]._sc_const.none ) { return; };
    var _sc_display_strings = ["none","basic","standard","advanced"];
    var sc_display_cycler = _sc_display_strings[ worldScripts["Shield Cycler"]._sc_settings.sc.version ];
    var sc_display_manual = "";
    var sc_display_functional = worldScripts["Shield Cycler"]._sc_settings.sc.functional ;
    if ( worldScripts["Shield Cycler"]._sc_settings.sc.manual_version != worldScripts["Shield Cycler"]._sc_const.none )
      { 
        sc_display_manual = _sc_display_strings[ worldScripts["Shield Cycler"]._sc_settings.sc.manual_version ];
      };
    var instruct = 
      [
        "Shield Cycler Status",
        "SC version: "  + sc_display_cycler,
        "Manual Configurator: " + sc_display_manual,
        sc_display_functional + " %% functional"
      ];
    mission.setInstructions( instruct );
  };

this.playerWillSaveGame = function()
  {
    missionVariables.sc_settings = JSON.stringify(worldScripts["Shield Cycler"]._sc_settings);
  };

this.playerBoughtNewShip = function(ship)
  {
    // sell shieldcycler equipment if still present and reset missionvars
    if ( worldScripts["Shield Cycler"]._sc_settings.sc.version == worldScripts["Shield Cycler"]._sc_const.none ) { return; };
    var refund = 0;
    if ( worldScripts["Shield Cycler"]._sc_settings.sc.manual_version != worldScripts["Shield Cycler"]._sc_const.none ) 
      { 
	refund = worldScripts["Shield Cycler"]._sc_remove_manual();
      };
    refund += worldScripts["Shield Cycler"]._sc_remove_shield_cycler();
  };

this.equipmentDamaged = function(equipmentKey)
  {
    switch ( equipmentKey )
      {
	case "EQ_SC_SHIELD_CYCLER_INTERNAL":
	case "EQ_SC_MANUAL_CONFIGURATOR_INTERNAL":
	  player.commsMessage("ShieldCycler devices taking damage, functionality is reduced",6);
	  player.ship.setEquipmentStatus(EquipmentInfo.infoForKey(equipmentKey), "EQUIPMENT_OK");
	  if ( worldScripts["Shield Cycler"]._sc_settings.sc.functional >= 50 )
	    { worldScripts["Shield Cycler"]._sc_settings.sc.functional -= 10; }
	  else
	    {  worldScripts["Shield Cycler"]._sc_settings.sc.functional = 40; };
	  break;
	default:
	  break;
      };
  };

this.playerBoughtEquipment = function(equipmentKey)
  {
    // This function supplements the code in equipment.plist & SC_Equipment_Condtion.js
    switch ( equipmentKey )
        {
          case "EQ_SC_SHIELD_CYCLER_BASIC":
            player.ship.removeEquipment(equipmentKey);
	    player.ship.awardEquipment("EQ_SC_SHIELD_CYCLER_INTERNAL");
            worldScripts["Shield Cycler"]._sc_settings.sc.start_configuration = worldScripts["Shield Cycler"]._sc_const.cycle.both;
            worldScripts["Shield Cycler"]._sc_settings.sc.threshold = 100;
	    worldScripts["Shield Cycler"]._sc_update_oxpconfig_vars();
            worldScripts["Shield Cycler"]._sc_settings.sc.functional = 100;
	    worldScripts["Shield Cycler"]._sc_settings.sc.version  = worldScripts["Shield Cycler"]._sc_const.basic;
            break;
          case "EQ_SC_SHIELD_CYCLER_STANDARD":
            player.ship.removeEquipment(equipmentKey);
            worldScripts["Shield Cycler"]._sc_change_configuration(1, false);
	    worldScripts["Shield Cycler"]._sc_settings.sc.version  = worldScripts["Shield Cycler"]._sc_const.standard;
            break;
          case "EQ_SC_SHIELD_CYCLER_ADVANCED":
            player.ship.removeEquipment(equipmentKey);
            worldScripts["Shield Cycler"]._sc_change_configuration(2, false);
	    worldScripts["Shield Cycler"]._sc_settings.sc.version  = worldScripts["Shield Cycler"]._sc_const.advanced;
            break;
          case "EQ_SC_MANUAL_CONFIGURATOR_BASIC":
	    player.ship.removeEquipment(equipmentKey);
            player.ship.awardEquipment("EQ_SC_MANUAL_CONFIGURATOR_INTERNAL");
            worldScripts["Shield Cycler"]._sc_settings.sc.cycler_mask  = 0x00f;
	    worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  = worldScripts["Shield Cycler"]._sc_const.basic;
            break;
          case "EQ_SC_MANUAL_CONFIGURATOR_STANDARD":
	    player.ship.removeEquipment(equipmentKey);
	    worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  = worldScripts["Shield Cycler"]._sc_const.standard;
            break;
          case "EQ_SC_MANUAL_CONFIGURATOR_ADVANCED":
	    player.ship.removeEquipment(equipmentKey);
            worldScripts["Shield Cycler"]._sc_change_configuration(3, false);
	    worldScripts["Shield Cycler"]._sc_settings.sc.manual_version  = worldScripts["Shield Cycler"]._sc_const.advanced;
            break;
          case "EQ_SC_SELL_MANUAL_CONFIGURATOR":
            player.credits = player.credits + worldscripts["Shield Cycler"]._sc_remove_manual();
            break;
	  case "EQ_SC_SELL_SHIELD_CYCLER":
            player.credits = player.credits + worldscripts["Shield Cycler"]._sc_remove_shield_cycler();
            break;
	  case "EQ_SC_SC_REPAIR":
            worldScripts["Shield Cycler"]._sc_settings.sc.functional = 100;
	    break;
          default:
            break;
        };
  };
